# Class VulkanPipelineViewportStateCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanPipelineViewportStateCreateInfo

All Implemented Interfaces:
  `VulkanPipelineViewportStateCreateInfoType`

public final class VulkanPipelineViewportStateCreateInfo extends Object implements VulkanPipelineViewportStateCreateInfoType

See Also:
  - "VkPipelineViewportStateCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanPipelineViewportStateCreateInfo.Builder`
  Builds instances of type `VulkanPipelineViewportStateCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanPipelineViewportStateCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanPipelineViewportStateCreateInfo`.
  `static VulkanPipelineViewportStateCreateInfo`
  `copyOf(VulkanPipelineViewportStateCreateInfoType instance)`
  Creates an immutable copy of a `VulkanPipelineViewportStateCreateInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanPipelineViewportStateCreateInfo` that have equal attribute values.
  `Set<VulkanPipelineViewportStateCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `viewports`, `scissors`.
  `List<VulkanRectangle2D>`
  `scissors()`
  `String`
  `toString()`
  Prints the immutable value `VulkanPipelineViewportStateCreateInfo` with attribute values.
  `List<VulkanViewport>`
  `viewports()`
  `final VulkanPipelineViewportStateCreateInfo`
  `withFlags(VulkanPipelineViewportStateCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineViewportStateCreateInfo`
  `withFlags(Iterable<VulkanPipelineViewportStateCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanPipelineViewportStateCreateInfo`
  `withScissors(VulkanRectangle2D... elements)`
  Copy the current immutable object with elements that replace the content of `scissors`.
  `final VulkanPipelineViewportStateCreateInfo`
  `withScissors(Iterable<? extends VulkanRectangle2D> elements)`
  Copy the current immutable object with elements that replace the content of `scissors`.
  `final VulkanPipelineViewportStateCreateInfo`
  `withViewports(VulkanViewport... elements)`
  Copy the current immutable object with elements that replace the content of `viewports`.
  `final VulkanPipelineViewportStateCreateInfo`
  `withViewports(Iterable<? extends VulkanViewport> elements)`
  Copy the current immutable object with elements that replace the content of `viewports`.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanPipelineViewportStateCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanPipelineViewportStateCreateInfoType`
    Returns:
      Flags reserved for future use

  - ### viewports

    public List<VulkanViewport> viewports()
    Specified by:
      `viewports` in interface `VulkanPipelineViewportStateCreateInfoType`
    Returns:
      The viewport transforms.

  - ### scissors

    public List<VulkanRectangle2D> scissors()
    Specified by:
      `scissors` in interface `VulkanPipelineViewportStateCreateInfoType`
    Returns:
      The scissor for the corresponding viewports.

  - ### withFlags

    public final VulkanPipelineViewportStateCreateInfo withFlags(VulkanPipelineViewportStateCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanPipelineViewportStateCreateInfo withFlags(Iterable<VulkanPipelineViewportStateCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### withViewports

    public final VulkanPipelineViewportStateCreateInfo withViewports(VulkanViewport... elements)
    Copy the current immutable object with elements that replace the content of `viewports`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withViewports

    public final VulkanPipelineViewportStateCreateInfo withViewports(Iterable<? extends VulkanViewport> elements)
    Copy the current immutable object with elements that replace the content of `viewports`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of viewports elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### withScissors

    public final VulkanPipelineViewportStateCreateInfo withScissors(VulkanRectangle2D... elements)
    Copy the current immutable object with elements that replace the content of `scissors`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withScissors

    public final VulkanPipelineViewportStateCreateInfo withScissors(Iterable<? extends VulkanRectangle2D> elements)
    Copy the current immutable object with elements that replace the content of `scissors`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of scissors elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanPipelineViewportStateCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `viewports`, `scissors`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanPipelineViewportStateCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanPipelineViewportStateCreateInfo copyOf(VulkanPipelineViewportStateCreateInfoType instance)
    Creates an immutable copy of a `VulkanPipelineViewportStateCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanPipelineViewportStateCreateInfo instance

  - ### builder

    public static VulkanPipelineViewportStateCreateInfo.Builder builder()
    Creates a builder for `VulkanPipelineViewportStateCreateInfo`.

        VulkanPipelineViewportStateCreateInfo.builder()
           .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanPipelineViewportStateCreateFlag) // flags elements
           .addViewports|addAllViewports(VulkanViewport) // viewports elements
           .addScissors|addAllScissors(VulkanRectangle2D) // scissors elements
           .build();

    Returns:
      A new VulkanPipelineViewportStateCreateInfo builder